// ----------------------------------------------------------------------------
//
//     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
//
// ----------------------------------------------------------------------------
//
//     This file is automatically generated by Magic Modules and manual
//     changes will be clobbered when the file is regenerated.
//
//     Please read more about how to change this file in
//     .github/CONTRIBUTING.md.
//
// ----------------------------------------------------------------------------

package google

import (
	"fmt"
	"testing"

	"github.com/hashicorp/terraform-plugin-sdk/helper/acctest"
	"github.com/hashicorp/terraform-plugin-sdk/helper/resource"
)

func TestAccIapAppEngineVersionIamBindingGenerated(t *testing.T) {
	t.Parallel()

	context := map[string]interface{}{
		"random_suffix":   acctest.RandString(10),
		"role":            "roles/iap.httpsResourceAccessor",
		"condition_title": "expires_after_2019_12_31",
		"condition_expr":  `request.time < timestamp(\"2020-01-01T00:00:00Z\")`,
	}

	resource.Test(t, resource.TestCase{
		PreCheck:  func() { testAccPreCheck(t) },
		Providers: testAccProviders,
		Steps: []resource.TestStep{
			{
				Config: testAccIapAppEngineVersionIamBinding_basicGenerated(context),
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_binding.foo",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s roles/iap.httpsResourceAccessor", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
			{
				// Test Iam Binding update
				Config: testAccIapAppEngineVersionIamBinding_updateGenerated(context),
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_binding.foo",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s roles/iap.httpsResourceAccessor", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
		},
	})
}

func TestAccIapAppEngineVersionIamMemberGenerated(t *testing.T) {
	t.Parallel()

	context := map[string]interface{}{
		"random_suffix":   acctest.RandString(10),
		"role":            "roles/iap.httpsResourceAccessor",
		"condition_title": "expires_after_2019_12_31",
		"condition_expr":  `request.time < timestamp(\"2020-01-01T00:00:00Z\")`,
	}

	resource.Test(t, resource.TestCase{
		PreCheck:  func() { testAccPreCheck(t) },
		Providers: testAccProviders,
		Steps: []resource.TestStep{
			{
				// Test Iam Member creation (no update for member, no need to test)
				Config: testAccIapAppEngineVersionIamMember_basicGenerated(context),
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_member.foo",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s roles/iap.httpsResourceAccessor user:admin@hashicorptest.com", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
		},
	})
}

func TestAccIapAppEngineVersionIamPolicyGenerated(t *testing.T) {
	t.Parallel()

	context := map[string]interface{}{
		"random_suffix":   acctest.RandString(10),
		"role":            "roles/iap.httpsResourceAccessor",
		"condition_title": "expires_after_2019_12_31",
		"condition_expr":  `request.time < timestamp(\"2020-01-01T00:00:00Z\")`,
	}

	resource.Test(t, resource.TestCase{
		PreCheck:  func() { testAccPreCheck(t) },
		Providers: testAccProviders,
		Steps: []resource.TestStep{
			{
				Config: testAccIapAppEngineVersionIamPolicy_basicGenerated(context),
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_policy.foo",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
		},
	})
}

func TestAccIapAppEngineVersionIamBindingGenerated_withCondition(t *testing.T) {
	t.Parallel()

	context := map[string]interface{}{
		"random_suffix":   acctest.RandString(10),
		"role":            "roles/iap.httpsResourceAccessor",
		"condition_title": "expires_after_2019_12_31",
		"condition_expr":  `request.time < timestamp(\"2020-01-01T00:00:00Z\")`,
	}

	resource.Test(t, resource.TestCase{
		PreCheck:  func() { testAccPreCheck(t) },
		Providers: testAccProviders,
		Steps: []resource.TestStep{
			{
				Config: testAccIapAppEngineVersionIamBinding_withConditionGenerated(context),
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_binding.foo",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s roles/iap.httpsResourceAccessor %s", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"], context["condition_title"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
		},
	})
}

func TestAccIapAppEngineVersionIamBindingGenerated_withAndWithoutCondition(t *testing.T) {
	t.Parallel()

	context := map[string]interface{}{
		"random_suffix":   acctest.RandString(10),
		"role":            "roles/iap.httpsResourceAccessor",
		"condition_title": "expires_after_2019_12_31",
		"condition_expr":  `request.time < timestamp(\"2020-01-01T00:00:00Z\")`,
	}

	resource.Test(t, resource.TestCase{
		PreCheck:  func() { testAccPreCheck(t) },
		Providers: testAccProviders,
		Steps: []resource.TestStep{
			{
				Config: testAccIapAppEngineVersionIamBinding_withAndWithoutConditionGenerated(context),
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_binding.foo",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s roles/iap.httpsResourceAccessor", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_binding.foo2",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s roles/iap.httpsResourceAccessor %s", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"], context["condition_title"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
		},
	})
}

func TestAccIapAppEngineVersionIamMemberGenerated_withCondition(t *testing.T) {
	t.Parallel()

	context := map[string]interface{}{
		"random_suffix":   acctest.RandString(10),
		"role":            "roles/iap.httpsResourceAccessor",
		"condition_title": "expires_after_2019_12_31",
		"condition_expr":  `request.time < timestamp(\"2020-01-01T00:00:00Z\")`,
	}

	resource.Test(t, resource.TestCase{
		PreCheck:  func() { testAccPreCheck(t) },
		Providers: testAccProviders,
		Steps: []resource.TestStep{
			{
				Config: testAccIapAppEngineVersionIamMember_withConditionGenerated(context),
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_member.foo",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s roles/iap.httpsResourceAccessor user:admin@hashicorptest.com %s", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"], context["condition_title"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
		},
	})
}

func TestAccIapAppEngineVersionIamMemberGenerated_withAndWithoutCondition(t *testing.T) {
	t.Parallel()

	context := map[string]interface{}{
		"random_suffix":   acctest.RandString(10),
		"role":            "roles/iap.httpsResourceAccessor",
		"condition_title": "expires_after_2019_12_31",
		"condition_expr":  `request.time < timestamp(\"2020-01-01T00:00:00Z\")`,
	}

	resource.Test(t, resource.TestCase{
		PreCheck:  func() { testAccPreCheck(t) },
		Providers: testAccProviders,
		Steps: []resource.TestStep{
			{
				Config: testAccIapAppEngineVersionIamMember_withAndWithoutConditionGenerated(context),
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_member.foo",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s roles/iap.httpsResourceAccessor user:admin@hashicorptest.com", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_member.foo2",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s roles/iap.httpsResourceAccessor user:admin@hashicorptest.com %s", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"], context["condition_title"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
		},
	})
}

func TestAccIapAppEngineVersionIamPolicyGenerated_withCondition(t *testing.T) {
	t.Parallel()

	context := map[string]interface{}{
		"random_suffix":   acctest.RandString(10),
		"role":            "roles/iap.httpsResourceAccessor",
		"condition_title": "expires_after_2019_12_31",
		"condition_expr":  `request.time < timestamp(\"2020-01-01T00:00:00Z\")`,
	}

	resource.Test(t, resource.TestCase{
		PreCheck:  func() { testAccPreCheck(t) },
		Providers: testAccProviders,
		Steps: []resource.TestStep{
			{
				Config: testAccIapAppEngineVersionIamPolicy_withConditionGenerated(context),
			},
			{
				ResourceName:      "google_iap_app_engine_version_iam_policy.foo",
				ImportStateId:     fmt.Sprintf("projects/%s/iap_web/appengine-%s/services/%s/versions/%s", getTestProjectFromEnv(), getTestProjectFromEnv(), "default", context["random_suffix"]),
				ImportState:       true,
				ImportStateVerify: true,
			},
		},
	})
}

func testAccIapAppEngineVersionIamMember_basicGenerated(context map[string]interface{}) string {
	return Nprintf(`
resource "google_storage_bucket" "bucket" {
  name = "appengine-static-content-%{random_suffix}"
}

resource "google_storage_bucket_object" "object" {
  name   = "hello-world.zip"
  bucket = google_storage_bucket.bucket.name
  source = "./test-fixtures/appengine/hello-world.zip"
}

resource "google_app_engine_standard_app_version" "version" {
  version_id      = "%{random_suffix}"
  service         = "default"
  runtime         = "nodejs10"
  noop_on_destroy = false
  entrypoint {
    shell = "node ./app.js"
  }
  deployment {
    zip {
      source_url = "https://storage.googleapis.com/${google_storage_bucket.bucket.name}/hello-world.zip"
    }
  }
  env_variables = {
    port = "8080"
  }
}

resource "google_iap_app_engine_version_iam_member" "foo" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	role = "%{role}"
	member = "user:admin@hashicorptest.com"
}
`, context)
}

func testAccIapAppEngineVersionIamPolicy_basicGenerated(context map[string]interface{}) string {
	return Nprintf(`
resource "google_storage_bucket" "bucket" {
  name = "appengine-static-content-%{random_suffix}"
}

resource "google_storage_bucket_object" "object" {
  name   = "hello-world.zip"
  bucket = google_storage_bucket.bucket.name
  source = "./test-fixtures/appengine/hello-world.zip"
}

resource "google_app_engine_standard_app_version" "version" {
  version_id      = "%{random_suffix}"
  service         = "default"
  runtime         = "nodejs10"
  noop_on_destroy = false
  entrypoint {
    shell = "node ./app.js"
  }
  deployment {
    zip {
      source_url = "https://storage.googleapis.com/${google_storage_bucket.bucket.name}/hello-world.zip"
    }
  }
  env_variables = {
    port = "8080"
  }
}

data "google_iam_policy" "foo" {
	binding {
		role = "%{role}"
		members = ["user:admin@hashicorptest.com"]
	}
}

resource "google_iap_app_engine_version_iam_policy" "foo" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	policy_data = "${data.google_iam_policy.foo.policy_data}"
}
`, context)
}

func testAccIapAppEngineVersionIamBinding_basicGenerated(context map[string]interface{}) string {
	return Nprintf(`
resource "google_storage_bucket" "bucket" {
  name = "appengine-static-content-%{random_suffix}"
}

resource "google_storage_bucket_object" "object" {
  name   = "hello-world.zip"
  bucket = google_storage_bucket.bucket.name
  source = "./test-fixtures/appengine/hello-world.zip"
}

resource "google_app_engine_standard_app_version" "version" {
  version_id      = "%{random_suffix}"
  service         = "default"
  runtime         = "nodejs10"
  noop_on_destroy = false
  entrypoint {
    shell = "node ./app.js"
  }
  deployment {
    zip {
      source_url = "https://storage.googleapis.com/${google_storage_bucket.bucket.name}/hello-world.zip"
    }
  }
  env_variables = {
    port = "8080"
  }
}

resource "google_iap_app_engine_version_iam_binding" "foo" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	role = "%{role}"
	members = ["user:admin@hashicorptest.com"]
}
`, context)
}

func testAccIapAppEngineVersionIamBinding_updateGenerated(context map[string]interface{}) string {
	return Nprintf(`
resource "google_storage_bucket" "bucket" {
  name = "appengine-static-content-%{random_suffix}"
}

resource "google_storage_bucket_object" "object" {
  name   = "hello-world.zip"
  bucket = google_storage_bucket.bucket.name
  source = "./test-fixtures/appengine/hello-world.zip"
}

resource "google_app_engine_standard_app_version" "version" {
  version_id      = "%{random_suffix}"
  service         = "default"
  runtime         = "nodejs10"
  noop_on_destroy = false
  entrypoint {
    shell = "node ./app.js"
  }
  deployment {
    zip {
      source_url = "https://storage.googleapis.com/${google_storage_bucket.bucket.name}/hello-world.zip"
    }
  }
  env_variables = {
    port = "8080"
  }
}

resource "google_iap_app_engine_version_iam_binding" "foo" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	role = "%{role}"
	members = ["user:admin@hashicorptest.com", "user:paddy@hashicorp.com"]
}
`, context)
}

func testAccIapAppEngineVersionIamBinding_withConditionGenerated(context map[string]interface{}) string {
	return Nprintf(`
resource "google_storage_bucket" "bucket" {
  name = "appengine-static-content-%{random_suffix}"
}

resource "google_storage_bucket_object" "object" {
  name   = "hello-world.zip"
  bucket = google_storage_bucket.bucket.name
  source = "./test-fixtures/appengine/hello-world.zip"
}

resource "google_app_engine_standard_app_version" "version" {
  version_id      = "%{random_suffix}"
  service         = "default"
  runtime         = "nodejs10"
  noop_on_destroy = false
  entrypoint {
    shell = "node ./app.js"
  }
  deployment {
    zip {
      source_url = "https://storage.googleapis.com/${google_storage_bucket.bucket.name}/hello-world.zip"
    }
  }
  env_variables = {
    port = "8080"
  }
}

resource "google_iap_app_engine_version_iam_binding" "foo" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	role = "%{role}"
	members = ["user:admin@hashicorptest.com"]
	condition {
		title       = "%{condition_title}"
		description = "Expiring at midnight of 2019-12-31"
		expression  = "%{condition_expr}"
	}
}
`, context)
}

func testAccIapAppEngineVersionIamBinding_withAndWithoutConditionGenerated(context map[string]interface{}) string {
	return Nprintf(`
resource "google_storage_bucket" "bucket" {
  name = "appengine-static-content-%{random_suffix}"
}

resource "google_storage_bucket_object" "object" {
  name   = "hello-world.zip"
  bucket = google_storage_bucket.bucket.name
  source = "./test-fixtures/appengine/hello-world.zip"
}

resource "google_app_engine_standard_app_version" "version" {
  version_id      = "%{random_suffix}"
  service         = "default"
  runtime         = "nodejs10"
  noop_on_destroy = false
  entrypoint {
    shell = "node ./app.js"
  }
  deployment {
    zip {
      source_url = "https://storage.googleapis.com/${google_storage_bucket.bucket.name}/hello-world.zip"
    }
  }
  env_variables = {
    port = "8080"
  }
}

resource "google_iap_app_engine_version_iam_binding" "foo" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	role = "%{role}"
	members = ["user:admin@hashicorptest.com"]
}

resource "google_iap_app_engine_version_iam_binding" "foo2" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	role = "%{role}"
	members = ["user:admin@hashicorptest.com"]
	condition {
		title       = "%{condition_title}"
		description = "Expiring at midnight of 2019-12-31"
		expression  = "%{condition_expr}"
	}
}
`, context)
}

func testAccIapAppEngineVersionIamMember_withConditionGenerated(context map[string]interface{}) string {
	return Nprintf(`
resource "google_storage_bucket" "bucket" {
  name = "appengine-static-content-%{random_suffix}"
}

resource "google_storage_bucket_object" "object" {
  name   = "hello-world.zip"
  bucket = google_storage_bucket.bucket.name
  source = "./test-fixtures/appengine/hello-world.zip"
}

resource "google_app_engine_standard_app_version" "version" {
  version_id      = "%{random_suffix}"
  service         = "default"
  runtime         = "nodejs10"
  noop_on_destroy = false
  entrypoint {
    shell = "node ./app.js"
  }
  deployment {
    zip {
      source_url = "https://storage.googleapis.com/${google_storage_bucket.bucket.name}/hello-world.zip"
    }
  }
  env_variables = {
    port = "8080"
  }
}

resource "google_iap_app_engine_version_iam_member" "foo" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	role = "%{role}"
	member = "user:admin@hashicorptest.com"
	condition {
		title       = "%{condition_title}"
		description = "Expiring at midnight of 2019-12-31"
		expression  = "%{condition_expr}"
	}
}
`, context)
}

func testAccIapAppEngineVersionIamMember_withAndWithoutConditionGenerated(context map[string]interface{}) string {
	return Nprintf(`
resource "google_storage_bucket" "bucket" {
  name = "appengine-static-content-%{random_suffix}"
}

resource "google_storage_bucket_object" "object" {
  name   = "hello-world.zip"
  bucket = google_storage_bucket.bucket.name
  source = "./test-fixtures/appengine/hello-world.zip"
}

resource "google_app_engine_standard_app_version" "version" {
  version_id      = "%{random_suffix}"
  service         = "default"
  runtime         = "nodejs10"
  noop_on_destroy = false
  entrypoint {
    shell = "node ./app.js"
  }
  deployment {
    zip {
      source_url = "https://storage.googleapis.com/${google_storage_bucket.bucket.name}/hello-world.zip"
    }
  }
  env_variables = {
    port = "8080"
  }
}

resource "google_iap_app_engine_version_iam_member" "foo" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	role = "%{role}"
	member = "user:admin@hashicorptest.com"
}

resource "google_iap_app_engine_version_iam_member" "foo2" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	role = "%{role}"
	member = "user:admin@hashicorptest.com"
	condition {
		title       = "%{condition_title}"
		description = "Expiring at midnight of 2019-12-31"
		expression  = "%{condition_expr}"
	}
}
`, context)
}

func testAccIapAppEngineVersionIamPolicy_withConditionGenerated(context map[string]interface{}) string {
	return Nprintf(`
resource "google_storage_bucket" "bucket" {
  name = "appengine-static-content-%{random_suffix}"
}

resource "google_storage_bucket_object" "object" {
  name   = "hello-world.zip"
  bucket = google_storage_bucket.bucket.name
  source = "./test-fixtures/appengine/hello-world.zip"
}

resource "google_app_engine_standard_app_version" "version" {
  version_id      = "%{random_suffix}"
  service         = "default"
  runtime         = "nodejs10"
  noop_on_destroy = false
  entrypoint {
    shell = "node ./app.js"
  }
  deployment {
    zip {
      source_url = "https://storage.googleapis.com/${google_storage_bucket.bucket.name}/hello-world.zip"
    }
  }
  env_variables = {
    port = "8080"
  }
}

data "google_iam_policy" "foo" {
	binding {
		role = "%{role}"
		members = ["user:admin@hashicorptest.com"]
		condition {
			title       = "%{condition_title}"
			description = "Expiring at midnight of 2019-12-31"
			expression  = "%{condition_expr}"
		}
	}
}

resource "google_iap_app_engine_version_iam_policy" "foo" {
	project = "${google_app_engine_standard_app_version.version.project}"
	app_id = "${google_app_engine_standard_app_version.version.project}"
	service = "${google_app_engine_standard_app_version.version.service}"
	version_id = "${google_app_engine_standard_app_version.version.version_id}"
	policy_data = "${data.google_iam_policy.foo.policy_data}"
}
`, context)
}
